
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#详解format函数，各种格式化 / 憋错料</title>

    <meta name="description" content="C#详解format函数，各种格式化 一.String Format for Double Digits after decimal point This example formats double to string with fixed number of decimal places. For two decimal places use pattern „0.00“. If a float number has less decimal places, the rest digits on the right will b">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C#详解format函数，各种格式化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>一、String Format for Double</h1>
<h2>Digits after decimal point</h2>
<p>This example formats double to string with&nbsp;<strong>fixed number of decimal places</strong>. For two decimal places use pattern &bdquo;<strong>0.00</strong>&ldquo;. If a float number has less decimal places, the rest digits on the right will be zeroes. If it has more decimal places, the number will be rounded.</p>
<p>[C#]</p>
<pre>// just two decimal places
String.Format("{0:0.00}", 123.4567);      // "123.46"
String.Format("{0:0.00}", 123.4);         // "123.40"
String.Format("{0:0.00}", 123.0);         // "123.00"
</pre>
<p>Next example formats double to string with&nbsp;<strong>floating number of decimal places</strong>. E.g. for maximal two decimal places use pattern &bdquo;<strong>0.##</strong>&ldquo;.</p>
<p>[C#]</p>
<pre>// max. two decimal places
String.Format("{0:0.##}", 123.4567);      // "123.46"
String.Format("{0:0.##}", 123.4);         // "123.4"
String.Format("{0:0.##}", 123.0);         // "123"
</pre>
<h2>Digits before decimal point</h2>
<p>If you want a float number to have any&nbsp;<strong>minimal number of digits before decimal point</strong>&nbsp;use N-times zero before decimal point. E.g. pattern &bdquo;<strong>00.0</strong>&ldquo; formats a float number to string with at least two digits before decimal point and one digit after&nbsp;that.</p>
<p>[C#]</p>
<pre>// at least two digits before decimal point
String.Format("{0:00.0}", 123.4567);      // "123.5"
String.Format("{0:00.0}", 23.4567);       // "23.5"
String.Format("{0:00.0}", 3.4567);        // "03.5"
String.Format("{0:00.0}", -3.4567);       // "-03.5"
</pre>
<h2>Thousands separator</h2>
<p>To format double to string&nbsp;<strong>with use of thousands separator</strong>&nbsp;use zero and comma separator before an usual float formatting pattern, e.g. pattern &bdquo;<strong>0,0.0</strong>&ldquo; formats the number to use thousands separators and to have one decimal&nbsp;place.</p>
<p>[C#]</p>
<pre>String.Format("{0:0,0.0}", 12345.67);     // "12,345.7"
String.Format("{0:0,0}", 12345.67);       // "12,346"
</pre>
<h2>Zero</h2>
<p>Float&nbsp;<strong>numbers between zero and one</strong>&nbsp;can be formatted in two ways, with or without leading zero before decimal point. To format number without a leading zero use&nbsp;<strong>#</strong>&nbsp;before point. For example &bdquo;<strong>#.0</strong>&ldquo; formats number to have one decimal place and zero to N digits before decimal point (e.g. &bdquo;.5&ldquo; or &bdquo;123.5&ldquo;).</p>
<p>Following code shows&nbsp;<strong>how can be formatted a zero</strong>&nbsp;(of double&nbsp;type).</p>
<p>[C#]</p>
<pre>String.Format("{0:0.0}", 0.0);            // "0.0"
String.Format("{0:0.#}", 0.0);            // "0"
String.Format("{0:#.0}", 0.0);            // ".0"
String.Format("{0:#.#}", 0.0);            // ""
</pre>
<h2>Align numbers with spaces</h2>
<p>To align float number&nbsp;<strong>to the right</strong>&nbsp;use comma &bdquo;<strong>,</strong>&ldquo; option before the colon. Type comma followed by a number of spaces, e.g. &bdquo;<strong>0,10:0.0</strong>&ldquo; (this can be used only in&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.string.format.aspx" rel="external nofollow noreferrer">String.Format</a>&nbsp;method, not in<a href="http://msdn2.microsoft.com/en-us/library/kfsatb94.aspx" rel="external nofollow noreferrer">double.ToString</a>&nbsp;method). To align numbers&nbsp;<strong>to the left</strong>&nbsp;use negative number of spaces.</p>
<p>[C#]</p>
<pre>String.Format("{0,10:0.0}", 123.4567);    // "     123.5"
String.Format("{0,-10:0.0}", 123.4567);   // "123.5     "
String.Format("{0,10:0.0}", -123.4567);   // "    -123.5"
String.Format("{0,-10:0.0}", -123.4567);  // "-123.5    "
</pre>
<h2>Custom formatting for negative numbers and zero</h2>
<p>If you need to use custom format for negative float numbers or zero, use&nbsp;<strong>semicolon separator</strong>&nbsp;&bdquo;<strong>;</strong>&ldquo; to split pattern to&nbsp;<strong>three sections</strong>. The first section formats positive numbers, the&nbsp;<strong>second section formats negative numbers</strong>&nbsp;and the third section formats zero. If you omit the last section, zero will be formatted using the first section.</p>
<p>[C#]</p>
<pre>String.Format("{0:0.00;minus 0.00;zero}", 123.4567);   // "123.46"
String.Format("{0:0.00;minus 0.00;zero}", -123.4567);  // "minus 123.46"
String.Format("{0:0.00;minus 0.00;zero}", 0.0);        // "zero"
</pre>
<h2>Some funny examples</h2>
<p>As you could notice in the previous example, you can put any text into formatting pattern, e.g. before an usual pattern &bdquo;<strong><em>my text&nbsp;</em>0.0</strong>&ldquo;. You can even put any text between the zeroes, e.g. &bdquo;<strong>0<em>aaa</em>.<em>bbb</em>0</strong>&ldquo;.</p>
<p>[C#]</p>
<pre>String.Format("{0:my number is 0.0}", 12.3);   // "my number is 12.3"
String.Format("{0:0aaa.bbb0}", 12.3);          // "12aaa.bbb3"
</pre>
<h1>二、String Format for Int</h1>
<p>Integer numbers can be formatted in .NET in many ways. You can use static method String.<a href="http://msdn2.microsoft.com/en-us/library/system.string.format.aspx" rel="external nofollow noreferrer">Format</a>or instance method int.<a href="http://msdn2.microsoft.com/en-us/library/system.int32.tostring.aspx" rel="external nofollow noreferrer">ToString</a>. Following examples show how to align numbers (with spaces or zeroes), how to format negative numbers or how to do custom formatting like phone numbers.</p>
<h2>Add zeroes before number</h2>
<p>To add zeroes before a number, use&nbsp;<strong>colon separator &bdquo;:&ldquo;</strong>&nbsp;and write as many zeroes as you&nbsp;want.</p>
<p>[C#]</p>
<pre>String.Format("{0:00000}", 15);          // "00015"
String.Format("{0:00000}", -15);         // "-00015"
</pre>
<h2>Align number to the right or left</h2>
<p>To align number to the right, use&nbsp;<strong>comma &bdquo;,&ldquo;</strong>&nbsp;followed by a number of characters. This alignment option must be before the colon separator.</p>
<p>[C#]</p>
<pre>String.Format("{0,5}", 15);              // "   15"
String.Format("{0,-5}", 15);             // "15   "
String.Format("{0,5:000}", 15);          // "  015"
String.Format("{0,-5:000}", 15);         // "015  "
</pre>
<h2>Different formatting for negative numbers and zero</h2>
<p>You can have special format for negative numbers and zero. Use&nbsp;<strong>semicolon separator &bdquo;;&ldquo;</strong>&nbsp;to separate formatting to two or three sections. The second section is format for negative numbers, the third section is for&nbsp;zero.</p>
<p>[C#]</p>
<pre>String.Format("{0:#;minus #}", 15);      // "15"
String.Format("{0:#;minus #}", -15);     // "minus 15"
String.Format("{0:#;minus #;zero}", 0);  // "zero"
</pre>
<h2>Custom number formatting (e.g. phone number)</h2>
<p>Numbers can be formatted also to any custom format, e.g. like phone numbers or serial numbers.</p>
<p>[C#]</p>
<pre>String.Format("{0:+### ### ### ###}", 447900123456); // "+447 900 123 456"
String.Format("{0:##-####-####}", 8958712551);       // "89-5871-2551"
</pre>
<h1>三、String Format for DateTime</h1>
<p>This example shows how to format&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.datetime.aspx" rel="external nofollow noreferrer">DateTime</a>&nbsp;using&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.string.format.aspx" rel="external nofollow noreferrer">String.Format</a>&nbsp;method. All formatting can be done also using&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/zdtaw1bw.aspx" rel="external nofollow noreferrer">DateTime.ToString</a>&nbsp;method.</p>
<h2>Custom DateTime Formatting</h2>
<p>There are following custom format specifiers&nbsp;<code>y</code>&nbsp;(year),&nbsp;<code>M</code>&nbsp;(month),&nbsp;<code>d</code>&nbsp;(day),&nbsp;<code>h</code>&nbsp;(hour 12),&nbsp;<code>H</code>&nbsp;(hour 24),<code>m</code>&nbsp;(minute),&nbsp;<code>s</code>&nbsp;(second),&nbsp;<code>f</code>&nbsp;(second fraction),&nbsp;<code>F</code>&nbsp;(second fraction, trailing zeroes are trimmed),&nbsp;<code>t</code>&nbsp;(P.M or A.M) and&nbsp;<code>z</code>&nbsp;(time&nbsp;zone).</p>
<p>Following examples demonstrate how are the format specifiers rewritten to the output.</p>
<p>[C#]</p>
<pre>// create date time 2008-03-09 16:05:07.123
DateTime dt = new DateTime(2008, 3, 9, 16, 5, 7, 123);

String.Format("{0:y yy yyy yyyy}", dt);  // "8 08 008 2008"   year
String.Format("{0:M MM MMM MMMM}", dt);  // "3 03 Mar March"  month
String.Format("{0:d dd ddd dddd}", dt);  // "9 09 Sun Sunday" day
String.Format("{0:h hh H HH}",     dt);  // "4 04 16 16"      hour 12/24
String.Format("{0:m mm}",          dt);  // "5 05"            minute
String.Format("{0:s ss}",          dt);  // "7 07"            second
String.Format("{0:f ff fff ffff}", dt);  // "1 12 123 1230"   sec.fraction
String.Format("{0:F FF FFF FFFF}", dt);  // "1 12 123 123"    without zeroes
String.Format("{0:t tt}",          dt);  // "P PM"            A.M. or P.M.
String.Format("{0:z zz zzz}",      dt);  // "-6 -06 -06:00"   time zone
</pre>
<p>You can use also&nbsp;<strong>date separator</strong>&nbsp;<code>/</code>&nbsp;(slash) and&nbsp;<strong>time sepatator</strong>&nbsp;<code>:</code>&nbsp;(colon). These characters will be rewritten to characters defined in the current&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.datetimeformatinfo.dateseparator.aspx" rel="external nofollow noreferrer">DateTimeForma&shy;tInfo.DateSepa&shy;rator</a>&nbsp;and<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.datetimeformatinfo.timeseparator.aspx" rel="external nofollow noreferrer">DateTimeForma&shy;tInfo.TimeSepa&shy;rator</a>.</p>
<p>[C#]</p>
<pre>// date separator in german culture is "." (so "/" changes to ".")
String.Format("{0:d/M/yyyy HH:mm:ss}", dt); // "9/3/2008 16:05:07" - english (en-US)
String.Format("{0:d/M/yyyy HH:mm:ss}", dt); // "9.3.2008 16:05:07" - german (de-DE)
</pre>
<p>Here are some examples of custom date and time formatting:</p>
<p>[C#]</p>
<pre>// month/day numbers without/with leading zeroes
String.Format("{0:M/d/yyyy}", dt);            // "3/9/2008"
String.Format("{0:MM/dd/yyyy}", dt);          // "03/09/2008"

// day/month names
String.Format("{0:ddd, MMM d, yyyy}", dt);    // "Sun, Mar 9, 2008"
String.Format("{0:dddd, MMMM d, yyyy}", dt);  // "Sunday, March 9, 2008"

// two/four digit year
String.Format("{0:MM/dd/yy}", dt);            // "03/09/08"
String.Format("{0:MM/dd/yyyy}", dt);          // "03/09/2008"
</pre>
<h2>Standard DateTime Formatting</h2>
<p>In&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.datetimeformatinfo.aspx" rel="external nofollow noreferrer">DateTimeForma&shy;tInfo</a>&nbsp;there are defined standard patterns for the current culture. For example property&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.datetimeformatinfo.shorttimepattern.aspx" rel="external nofollow noreferrer">ShortTimePattern</a>&nbsp;is string that contains value&nbsp;<code>h:mm tt</code>&nbsp;for&nbsp;<strong>en-US</strong>&nbsp;culture and value&nbsp;<code>HH:mm</code>for&nbsp;<strong>de-DE</strong>&nbsp;culture.</p>
<p>Following table shows patterns defined in&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.datetimeformatinfo.aspx" rel="external nofollow noreferrer">DateTimeForma&shy;tInfo</a>&nbsp;and their values for en-US culture. First column contains format specifiers for the&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.string.format.aspx" rel="external nofollow noreferrer">String.Format</a>&nbsp;method.</p>
<table>
<tbody>
<tr>
<th>Specifier</th>
<th>DateTimeFormatInfo property</th>
<th>Pattern value (for en-US culture)</th>
</tr>
<tr>
<td><code>t</code></td>
<td>ShortTimePattern</td>
<td><code>h:mm tt</code></td>
</tr>
<tr>
<td><code>d</code></td>
<td>ShortDatePattern</td>
<td><code>M/d/yyyy</code></td>
</tr>
<tr>
<td><code>T</code></td>
<td>LongTimePattern</td>
<td><code>h:mm:ss tt</code></td>
</tr>
<tr>
<td><code>D</code></td>
<td>LongDatePattern</td>
<td><code>dddd, MMMM dd, yyyy</code></td>
</tr>
<tr>
<td><code>f</code></td>
<td><em>(combination of&nbsp;<code>D</code>&nbsp;and&nbsp;<code>t</code>)</em></td>
<td><code>dddd, MMMM dd, yyyy h:mm tt</code></td>
</tr>
<tr>
<td><code>F</code></td>
<td>FullDateTimePattern</td>
<td><code>dddd, MMMM dd, yyyy h:mm:ss tt</code></td>
</tr>
<tr>
<td><code>g</code></td>
<td><em>(combination of&nbsp;<code>d</code>&nbsp;and&nbsp;<code>t</code>)</em></td>
<td><code>M/d/yyyy h:mm tt</code></td>
</tr>
<tr>
<td><code>G</code></td>
<td><em>(combination of&nbsp;<code>d</code>&nbsp;and&nbsp;<code>T</code>)</em></td>
<td><code>M/d/yyyy h:mm:ss tt</code></td>
</tr>
<tr>
<td><code>m</code>,&nbsp;<code>M</code></td>
<td>MonthDayPattern</td>
<td><code>MMMM dd</code></td>
</tr>
<tr>
<td><code>y</code>,&nbsp;<code>Y</code></td>
<td>YearMonthPattern</td>
<td><code>MMMM, yyyy</code></td>
</tr>
<tr>
<td><code>r</code>,&nbsp;<code>R</code></td>
<td>RFC1123Pattern</td>
<td><code>ddd, dd MMM yyyy HH‘:‘mm‘:‘ss ‘GMT‘</code>&nbsp;<em>(*)</em></td>
</tr>
<tr>
<td><code>s</code></td>
<td>SortableDateTi&shy;mePattern</td>
<td><code>yyyy‘-‘MM‘-‘dd‘T‘HH‘:‘mm‘:‘ss</code>&nbsp;<em>(*)</em></td>
</tr>
<tr>
<td><code>u</code></td>
<td>UniversalSorta&shy;bleDateTimePat&shy;tern</td>
<td><code>yyyy‘-‘MM‘-‘dd HH‘:‘mm‘:‘ss‘Z‘</code>&nbsp;<em>(*)</em></td>
</tr>
<tr>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td><em>(*) = culture independent</em></td>
</tr>
</tbody>
</table>
<p>Following examples show usage of&nbsp;<strong>standard format specifiers</strong>&nbsp;in&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.string.format.aspx" rel="external nofollow noreferrer">String.Format</a>&nbsp;method and the resulting output.</p>
<p>[C#]</p>
<pre>String.Format("{0:t}", dt);  // "4:05 PM"                         ShortTime
String.Format("{0:d}", dt);  // "3/9/2008"                        ShortDate
String.Format("{0:T}", dt);  // "4:05:07 PM"                      LongTime
String.Format("{0:D}", dt);  // "Sunday, March 09, 2008"          LongDate
String.Format("{0:f}", dt);  // "Sunday, March 09, 2008 4:05 PM"  LongDate+ShortTime
String.Format("{0:F}", dt);  // "Sunday, March 09, 2008 4:05:07 PM" FullDateTime
String.Format("{0:g}", dt);  // "3/9/2008 4:05 PM"                ShortDate+ShortTime
String.Format("{0:G}", dt);  // "3/9/2008 4:05:07 PM"             ShortDate+LongTime
String.Format("{0:m}", dt);  // "March 09"                        MonthDay
String.Format("{0:y}", dt);  // "March, 2008"                     YearMonth
String.Format("{0:r}", dt);  // "Sun, 09 Mar 2008 16:05:07 GMT"   RFC1123
String.Format("{0:s}", dt);  // "2008-03-09T16:05:07"             SortableDateTime
String.Format("{0:u}", dt);  // "2008-03-09 16:05:07Z"            UniversalSortableDateTime
</pre>
<h1>四、IFormatProvider for Numbers</h1>
<p>This example shows how to convert&nbsp;<strong>float to string</strong>&nbsp;and&nbsp;<strong>string to float</strong>&nbsp;using&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.iformatprovider.aspx" rel="external nofollow noreferrer">IFormatProvider</a>. To get IFormatProvider you need to get&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.cultureinfo_members.aspx" rel="external nofollow noreferrer">CultureInfo</a>&nbsp;instance&nbsp;first.</p>
<h2>Get invariant or specific CultureInfo</h2>
<p><strong>Invariant culture</strong>&nbsp;is a special type of culture which is culture-insensitive. You should use this culture when you need&nbsp;<strong>culture-independent results</strong>, e.g. when you format or parse values in XML file. The invariant culture is internally associated with the English language. To get invariant<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.cultureinfo_members.aspx" rel="external nofollow noreferrer">CultureInfo</a>&nbsp;instance use static property&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.cultureinfo.invariantculture.aspx" rel="external nofollow noreferrer">CultureInfo.In&shy;variantCulture</a>.</p>
<p>To get&nbsp;<strong>specific</strong>&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.cultureinfo_members.aspx" rel="external nofollow noreferrer">CultureInfo</a>&nbsp;instance use static method&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/yck8b540.aspx" rel="external nofollow noreferrer">CultureInfo.Get&shy;CultureInfo</a>&nbsp;with the specific<a href="http://www.csharp-examples.net/culture-names/" rel="external nofollow noreferrer">culture name</a>, e.g. for the German language&nbsp;<code>CultureInfo.GetCultureInfo("de-DE")</code>.</p>
<h2>Format and parse numbers using the IFormatProvider</h2>
<p>Once you have the CultureInfo instance use property&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.cultureinfo.numberformat.aspx" rel="external nofollow noreferrer">CultureInfo.Num&shy;berFormat</a>&nbsp;to get an<strong>IFormatProvider for numbers</strong>&nbsp;(the&nbsp;<a href="http://msdn2.microsoft.com/en-us/library/system.globalization.numberformatinfo.aspx" rel="external nofollow noreferrer">NumberFormatInfo</a>&nbsp;object)</p>
<p>[C#]</p>
<pre>// format float to string
float num = 1.5f;
string str = num.<strong>ToString</strong>(CultureInfo.InvariantCulture.<strong>NumberFormat</strong>);        // "1.5"
string str = num.<strong>ToString</strong>(CultureInfo.GetCultureInfo("de-DE").<strong>NumberFormat</strong>); // "1,5"
</pre>
<p>[C#]</p>
<pre>// parse float from string
float num = float.<strong>Parse</strong>("1.5", CultureInfo.InvariantCulture.<strong>NumberFormat</strong>);
float num = float.<strong>Parse</strong>("1,5", CultureInfo.GetCultureInfo("de-DE").<strong>NumberFormat</strong>);
</pre>
<h1>五、Custom IFormatProvider</h1>
<p>The following example shows how to write a custom&nbsp;<a href="http://msdn.microsoft.com/en-us/library/system.iformatprovider.aspx" rel="external nofollow noreferrer">IFormatProvider</a>&nbsp;which you can use in method<a href="http://msdn.microsoft.com/en-us/library/1ksz8yb7.aspx" rel="external nofollow noreferrer">String.Format</a>(I&shy;FormatProvider,&nbsp;&hellip;).</p>
<p>This formatter formats doubles to 3&nbsp;decimal places with a dot separator.</p>
<p>[C#]</p>
<pre>public class DoubleFormatter : IFormatProvider, ICustomFormatter
{
  // always use dot separator for doubles
  private CultureInfo enUsCulture = CultureInfo.GetCultureInfo("en-US");

  public string <strong>Format</strong>(string format, object arg, IFormatProvider formatProvider)
  {
    // format doubles to 3 decimal places
    return string.Format(enUsCulture, "{0:0.000}", arg);
  }

  public object <strong>GetFormat</strong>(Type formatType)
  {
    return (formatType == typeof(ICustomFormatter)) ? this : null;
  }
}
</pre>
<p>Having this formatter, we can use it like this:</p>
<p>[C#]</p>
<pre>double width = 15.77555;
double height = 12.8497979;
Console.WriteLine(
  string.Format(new DoubleFormatter(), "w={0} h={1}", width, height));
</pre>
<p>Output:</p>
<pre>w=15.776 h=12.850
</pre>
<p>So now we have a reusable format for doubles&nbsp;&ndash; 3&nbsp;decimal places with dot separator. That is nice, but this formatter is very simple&nbsp;&ndash; it formats everything (eg. DateTime) as &bdquo;0:000&ldquo;. This is a fast version if you know that you will only use it for formatting lots of doubles.</p>
<p>The real version should look like this:</p>
<p>[C#]</p>
<pre>public class DoubleFormatter : IFormatProvider, ICustomFormatter
{
  // always use dot separator for doubles
  private CultureInfo enUsCulture = CultureInfo.GetCultureInfo("en-US");

  public string <strong>Format</strong>(string format, object arg, IFormatProvider formatProvider)
  {
    if (arg is double)
    {
      if (string.IsNullOrEmpty(format))
      {
        // by default, format doubles to 3 decimal places
        return string.Format(enUsCulture, "{0:0.000}", arg);
      }
      else
      {
        // if user supplied own format use it
        return ((double)arg).ToString(format, enUsCulture);
      }
    }
    // format everything else normally
    if (arg is IFormattable)
      return ((IFormattable)arg).ToString(format, formatProvider);
    else
      return arg.ToString();
  }

  public object <strong>GetFormat</strong>(Type formatType)
  {
    return (formatType == typeof(ICustomFormatter)) ? this : null;
  }
}
</pre>
<p>Example:</p>
<p>[C#]</p>
<pre>Console.WriteLine(string.Format(new DoubleFormatter(),
 "Numbers {0} and {1:0.0}. Now a string {2}, a number {3}, date {4} and object: {5}",
 1.234567, -0.57123456, "Hi!", 5, DateTime.Now, new object()));
</pre>
<p>Output:</p>
<pre>Numbers 1.235 and -0.6. Now a string Hi!, a number 5, date 12.6.2009 17:11:35
and object: System.Object
</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 04:15:07 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C#详解format函数，各种格式化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35qK6o3.html" rel="bookmark">iOS插件详解之----CLangFormat&lpar;代码格式化管理插件&rpar;&lpar;2016&period;1&period;12王彬&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS插件详解之----CLangFormat(代码格式化管理)(2016.1.12王彬) 虽然在项目创建和团队组建的初期,我们就把公共约定以及一些规范定下来了,并且由于我们的代码是通过Git来做版本控制的,web上直接就支持Markdown格式的readme文件,可以随时看到最新的版本,但是这种规范只能依靠个人的意识,或者通过代码Review来解决,而且做代码Review的时候,你也不好意思总是写上一堆诸如“这里要加个空格”.“那里要加上换行”的评论吧?如果不管,久而久之,会因为每个人的习惯不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JAONP3.html" rel="bookmark">垃圾回收机制详解、运算符和格式化输出</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 垃圾回收机制详解.运算符和格式化输出 一.垃圾回收机制的原理 1 垃圾回收的原则 二.运算符 2.1 算术运算符 2.2 比较运算符 2.3 赋值运算符 2.4 逻辑运算符 2.5 成员运算符 2.6 身份运算符 三.格式化输出 3.1 % 占位符 3.2 str.format() 3.3 f&quot;&quot; 垃圾回收机制详解.运算符和格式化输出 一.垃圾回收机制的原理 当我们定义变量的时候,会申请一块内存空间用来存放变量值,然后利用赋值符号将变量名和变量值绑定在一起,接下来我们在使用变量值			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXvK5V3.html" rel="bookmark">详解JMeter函数和变量（转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				详解JMeter函数和变量(1) JMeter函数可以被认为是某种特殊的变量,它们可以被采样器或者其他测试元件所引用.函数调用的语法如下: ${__functionName(var1,var2,var3)} 其中,__functionName匹配被调用的函数名称.用圆括号包含函数的形参,例如${__time(YMD)},不同函数要求的参数也不同.有些JMeter函数不要求参数,则可以不使用圆括号,例如${__threadNum}. 如果一个函数的参数中包含逗号,那么必须对逗号进行转义(使用&quot;\&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgRLlB4.html" rel="bookmark">详解JMeter函数和变量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				详解JMeter函数和变量(1) JMeter函数可以被认为是某种特殊的变量,它们可以被采样器或者其他测试元件所引用.函数调用的语法如下: ${__functionName(var1,var2,var3)} 其中,__functionName匹配被调用的函数名称.用圆括号包含函数的形参,例如${__time(YMD)},不同函数要求的参数也不同.有些JMeter函数不要求参数,则可以不使用圆括号,例如${__threadNum}. 如果一个函数的参数中包含逗号,那么必须对逗号进行转义(使用&quot;\&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lDO2L0.html" rel="bookmark">PHP的ob&lowbar;start函数用法详解&lbrack;php函数&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用PHP的ob_start();控制您的浏览器cache Output Control 函数可以让你自由控制脚本中数据的输出.它非常地有用,特别是对于:当你想在数据已经输出后,再输出文件头的情况.输出控制函数不对使用 header() 或 setcookie(), 发送的文件头信息产生影响,只对那些类似于 echo() 和 PHP 代码的数据块有作用. 我们先举一个简单的例子,让大家对Output Control有一个大致的印象: Example 1. CODE&lt;?php ob_start();			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xW6LDM.html" rel="bookmark">ViewPager 详解（二）---详解四大函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言:上篇中我们讲解了如何快速实现了一个滑动页面,但问题在于,PageAdapter必须要重写的四个函数,它们都各有什么意义,在上节的函数内部为什么要这么实现,下面我们就结合Android的API说明,详细讲解一下. 相关文章: 1.&lt;ViewPager 详解(一)---基本入门&gt; 2.&lt;ViewPager 详解(二)---详解四大函数&gt; 3.&lt;ViewPager 详解(三)---PagerTabStrip与PagerTitleStrip添加标题栏的异同&gt; 4.&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6nR75M.html" rel="bookmark">图像处理中的数学原理详解19&mdash;&mdash;函数的极限</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				欢迎关注我的博客专栏&quot;图像处理中的数学原理详解&quot; 全文目录请见 图像处理中的数学原理详解(总纲) http://blog.csdn.net/baimafujinji/article/details/48467225 图像处理中的数学原理详解(已发布的部分链接整理) http://blog.csdn.net/baimafujinji/article/details/48751037 1.1.3 函数的极限 本小节介绍两个重要的函数极限,并讨论它们的应用. 重要极限1: 此外,该重要极限的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBXeKg3.html" rel="bookmark">C&plus;&plus;学习45  流成员函数put输出单个字符  cin输入流详解 get&lpar;&rpar;函数读入一个字符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在程序中一般用cout和插入运算符“&lt;&lt;”实现输出,cout流在内存中有相应的缓冲区.有时用户还有特殊的输出要求,例如只输出一个字符.ostream类除了提供上面介绍过的用于格式控制的成员函数外,还提供了专用于输出单个字符的成员函数put.如:    cout.put('a');调用该函数的结果是在屏幕上显示一个字符a.put函数的参数可以是字符或字符的ASCII代码(也可以是一个整型表达式).如    cout.put(65 + 32);也显示字符a,因为97是字符a的ASCII代码. 可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDmbqp0.html" rel="bookmark">Knowledge Point 20180303 详解main函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习Java的朋友想来都是从HelloWorld学起的,那么想来都对main函数不陌生了,但是main函数究竟是怎么回事呢?main函数中的参数是做什么的呢?main函数为什么能作为程序的入口呢?可不可以存在多个main函数呢?下面我们就来对main函数进行一些深入的了解. 1.Java中的main()方法详解 在Java中,main()方法是Java应用程序的入口方法,也就是说,程序在运行的时候,第一个执行的方法就是main()方法,这个方法和其他的方法有很大的不同,比如方法的名字必须是mai			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KaaWL4.html" rel="bookmark" class="title">C&num; walls</a>
					<div>
						在学习C#的阶段中,我们一点一点的往前爬, 此代码需要添加selenium ,和 获取 引用. using Ivony.Html.Parser; using Ivony.Html; using Ope ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvRwo0.html" rel="bookmark" class="title">iOS&lowbar;项目完成后测试app</a>
					<div>
						在项目中遇到各种问题: (1)thread 1:exc_bad_access(code=1,address=0x10) 完全不知道错误出现在哪里. 错误原因: exc_bad_access(code= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dgJLwM.html" rel="bookmark" class="title">linux下DHCP服务搭建</a>
					<div>
						实验环境 RHEL5.9 dhcp服务器 RHEL5.9 LINUX客户端 win7    windows客户端 实验前提: 1,服务器与客户机需要在同一个网段 2,dhcp需要有固定IP 实验步骤: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8Zd1M.html" rel="bookmark" class="title">图片在页面中居中显示</a>
					<div>
						参考1:http://www.lanrentuku.com:8081/js/table-188.html# 参考2:http://www.cnblogs.com/xueming/archive/201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8PVQ3.html" rel="bookmark" class="title">机器学习 &mdash;&mdash; 概率图模型（Homework&colon; Exact Inference）</a>
					<div>
						在前三周的作业中,我构造了概率图模型并调用第三方的求解器对器进行了求解,最终获得了每个随机变量的分布(有向图),最大后验分布(双向图).本周作业的主要内容就是自行编写概率图模型的求解器.实际上,从根本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrKGD4.html" rel="bookmark" class="title">约瑟夫环杂题</a>
					<div>
						N个人围成一圈顺序编号,从1号开始按1.2.3顺序报数,报3者退出圈外,其余的人再从1.2.3开始报数,报3的人再退出圈外,依次类推.请按退出顺序输出每个退出人的原序号.要求使用环行链表编程. 模拟题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmomdX3.html" rel="bookmark" class="title">HCE安全问题</a>
					<div>
						最近的项目中每每都会被问到:HCE安全吗? 我的答复是:相对安全. 听到我这样的回答,很多人可能会开始说了,某某银行都上HCE应用了,怎么不安全了? 其实,HCE应用的场景有两种:在线模式与离线模式. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpkrZ0.html" rel="bookmark" class="title">UESTC&lowbar;Can You Help God Wu CDOJ 582</a>
					<div>
						There is a boy named God Wu in UESTC ACM team. One day he is asked to finish a task. The task is tha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZAaR4.html" rel="bookmark" class="title">Linux下配置Tomcat&comma;及JDK</a>
					<div>
						Redhat Linux安装JDK 1.7 本篇主要介绍在Redhat Linux(Red Hat Enterprise Linux Server release 5.7 (Tikanga))系统上安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAP8O4.html" rel="bookmark" class="title">hihoCoder &num;1079 离散化</a>
					<div>
						P1 : 离散化 Time Limit:10000ms Case Time Limit:1000ms Memory Limit:256MB 描述 小Hi和小Ho在回国之后,重新过起了朝7晚5的学生生活 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzwR13.html" rel="bookmark" class="title">机器人开发平台</a>
					<div>
						导言 本文对目前现役实用机器人的软件开发平台进行整体的评测.其中的主要内容是根据本人对这些平台的实际使用经验编写的. 什么是机器人软件开发平台? 所谓的&quot;机器人软件开发平台&quot;我们指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7md93.html" rel="bookmark" class="title">Eclipse经常使用快捷键</a>
					<div>
						Eclipse有强大的编辑功能, 工欲善其事.必先利其器, 掌握Eclipse快捷键.能够大大提高工作效率. 凝视  Ctrl+/ 能为光标&quot;所在行&quot;或者&quot;选中行&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnyoP0.html" rel="bookmark" class="title">第12课-有名管道通讯</a>
					<div>
						1.有名管道:又称为FIFO文件.2.man命令:1.系统命令,2.系统调用,3库函数3.函数学习5.2 创建有名管道5.2.1 函数名mkfifo5.2.2 函数原形int mkfifo(const ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRZR94.html" rel="bookmark" class="title">自己定义泛型集合并实现foreach遍历</a>
					<div>
						1.首先创建一下SelfList&lt;T&gt;类; public class SelfList&lt;T&gt;:IEnumerable { } 2.添加默认的初始大小为4的Item数组; pub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eElra0.html" rel="bookmark" class="title">java多线程一览</a>
					<div>
						线程概述: 多线程的目的,不是提高程序的执行速度,而是提高程序的使用率(能抢到CPU的可能比较大). 因为线程是CPU调度的基本单位,所以,当一个程序的线程较多的时候就更容易抢到cpu的资源 进程:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEl5d4.html" rel="bookmark" class="title">bzoj 4199 &amp;amp&semi;&amp;amp&semi; NOI 2015 品酒大会</a>
					<div>
						一年一度的&quot;幻影阁夏日品酒大会&quot;隆重开幕了.大会包含品尝和趣味挑战两个环节,分别向优胜者颁发&quot;首席品酒家&quot;和&quot;首席猎手&quot;两个奖项,吸引了众多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oyna8M.html" rel="bookmark" class="title">MySQL---数据库从入门走向大神系列&lpar;十三&rpar;-BasicDataSource创建DataSource&lpar;DBCP连接池配置&rpar;</a>
					<div>
						DBCP(DataBase connection pool),数据库连接池.是 apache 上的一个 java 连接池项目,也是 tomcat 使用的连接池组件.单独使用dbcp需要2个包:comm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rm955M.html" rel="bookmark" class="title">Cannot load JDBC driver class &amp;&num;39&semi;oracle&period;jdbc&period;driver&period;OracleDriver&amp;&num;39&semi;</a>
					<div>
						: Cannot load JDBC driver class 'oracle.jdbc.driver.OracleDriver'错误来源:Cannot load JDBC driver class  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBwZn4.html" rel="bookmark" class="title">分享一个递归无限级拼接Json的方法---ExtJs的TreePanel和TreeGrid均适用&lpar;Ef，Lambda&comma;Linq&comma;IQueryable&comma;List&rpar;</a>
					<div>
						话不多说,先上实体类,如果你不是codefirst,就把它当成数据表结构. 下面是底层BaseDal获取数据的方法  (如果你没有Base类,直接写在你的DAL层和BLL层) 下面是BaseServi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDjewK3.html" rel="bookmark" class="title">Apple Pay之Payment Token技术浅析</a>
					<div>
						一.Token体系简介 Apple Pay引入的Token体系中,除了传统电子支付参与方外,新增了2个参与方,如下图所示: Token的应用原理:Token SP根据Token Requestor提供 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
